using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
{
        public static void Main()
        {
// register item to the mod registry
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Nullbody [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "HORAUGH.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("nullbody/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("nullbody/nullbody.png");
                        var flesh = ModAPI.LoadTexture("nullbody/flesh.png");
                        var bone = ModAPI.LoadTexture("nullbody/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(255, 181, 20); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(255, 169, 20); //second bruise colour. red by default
            person.SetThirdBruiseColor(255, 153, 20); // third bruise colour. light yellow by default
            person.SetRottenColour(144, 0, 255); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(255, 132, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Ford Clone [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "What up son?", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("fordclone/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("fordclone/skin.png");
                        var flesh = ModAPI.LoadTexture("null");
                        var bone = ModAPI.LoadTexture("null");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(138, 63, 63); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(54, 1, 3); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Arthur Ford [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "xX_TheRealFord_Xx", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("ford/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("ford/skin.png");
                        var flesh = ModAPI.LoadTexture("null");
                        var bone = ModAPI.LoadTexture("null");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(138, 63, 63); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(54, 1, 3); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
        {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Ford Early Exit [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "You dont want to see this at the foot of your bed at 4am.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("zombie/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
             var skin = ModAPI.LoadTexture("zombie/2.0.png");
                        var flesh = ModAPI.LoadTexture("zombie/zombflesh.png");
                        var bone = ModAPI.LoadTexture("null");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 149, 255); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 149, 255); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 149, 255); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 149, 255); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(0, 149, 255); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);



ModAPI.Register(
    new Modification()
        {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Corrupted Nullbody [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "*cough* *cough* HOR- *cough*", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("corruptnullbody/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("corruptnullbody/nullbody.png");
                        var flesh = ModAPI.LoadTexture("corruptnullbody/flesh.png");
                        var bone = ModAPI.LoadTexture("corruptnullbody/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(235, 255, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(245, 255, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(255, 255, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(144, 0, 255); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(255, 255, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);



ModAPI.Register(
    new Modification()
        {
        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
        NameOverride = "Omniworker - Android [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Android variant of normal omniprojector. A commentor requested to have this and personally I like the human version. So I kept both.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("omniworker/thumba.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("omniworker/skin.png");
                        var flesh = ModAPI.LoadTexture("omniworker/flesh.png");
                        var bone = ModAPI.LoadTexture("omniworker/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(255, 217, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(255, 217, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(255, 217, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(255, 217, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Omniworker [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "My own thing i made up. It's a mix between the Omniprojector from the game. And the grunts from the ending cutscene", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("omniworker/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("omniworker/skin.png");
            var flesh = ModAPI.LoadTexture("omniworker/flesh.png");
            var bone = ModAPI.LoadTexture("omniworker/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(255, 217, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(255, 217, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(255, 217, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(255, 217, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Gorse"), //item to derive from
        NameOverride = "Crablet [BWP: NPCS]", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Finally. You can stop commenting for me to add this.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("crablet/thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("crablet/skin.png");
            var flesh = ModAPI.LoadTexture("crablet/flesh.png");
            var bone = ModAPI.LoadTexture("crablet/skeleton.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(255, 181, 20); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(255, 169, 20); //second bruise colour. red by default
            person.SetThirdBruiseColor(255, 153, 20); // third bruise colour. light yellow by default
            person.SetRottenColour(144, 0, 255); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(255, 132, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

        }
    }
}